function a = stoch_specific_coeff(x,y,nel,norv,KL_DATA)
%STOCH_SPECIFIC_COEFF   synthetic stochastic diffusion coefficient
%   a = stoch_specific_coeff(x,y,nel,norv,KL_DATA)
%   input
%          x          x coordinate vector
%          y          y coordinate vector
%          nel        number of elements
%          norv       number of random variables
%       KL_DATA       data related to KL-expansion (6-fields structure or zero)
%
%   SIFISS function: DJS; 2 May 2013.
% Copyright (c) 2013 A. Bespalov, C.E. Powell, D.J. Silvester

% initialisation
  a=zeros(nel,norv+1);

% set a_0
  a(:,1)=ones(nel,1);

% set a_m
  for m=1:norv
      a(:,m+1) = 3.0e0*sin(m*pi*(x-y))/((m*pi)^2);
%%      a(:,m+1) = sin(m*pi*(x-y))/2;     This is ONLY to test the case of ONE random variable !
  end
return
